<template as="div">
    <div v-click-outside="onClickOutside">
        <div class="TextInput relative" :class="{ 'has-error': !!errorMessage, success: meta.valid }">
            <label @click="modelValue = disabled ? false : true" v-if="!!label"
                class="block mb-2 text-sm font-medium text-gray-900 " :for="name">{{ label }}</label>
            <div class="flex flex-row items-center">
                <div class="w-full" @click="modelValue = disabled ? false : true">
                    <input
                        class="bg-gray-50 border h-[46px] border-gray-300 text-gray-900 text-sm rounded-[5px] focus:ring-blue-500 focus:border-blue-500 block w-full p-2.5 "
                        :value="title" :class="{ 'cursor-not-allowed': disabled }" disabled />
                </div>

                <a class="ml-[-30px]" @click="handleChange('')" href="#" v-if="!disabled">
                    <fa-icon class="text-primary" icon="fa-solid fa-circle-xmark" />
                </a>
            </div>
            <input
                class="bg-gray-50 border h-[46px] border-gray-300 text-gray-900 text-sm rounded-[5px] focus:ring-blue-500 focus:border-blue-500 block w-full p-2.5 "
                :name="name" :id="name" type="hidden" :value="inputValue" :placeholder="placeholder"
                @input="handleChange" @blur="handleBlur" :class="{ 'cursor-not-allowed': disabled }" disabled />

            <p class="text-danger text-[13px] first-letter:uppercase" v-show="errorMessage || isInvalid">
                {{ errorMessage || errorMessageCustom }}
            </p>
        </div>
        <div>
            <div :class="{ 'hidden': !modelValue }"
                class="overflow-y-auto overflow-x-hidden fixed top-0 right-0 left-0 z-50 md:inset-0 h-modal md:h-full w-full flex justify-center items-center bg-black bg-opacity-50">
                <div class="relative p-4 w-full max-w-sm h-full md:h-auto ">
                    <div class="relative bg-white rounded-[20px] shadow ">
                        <div class="font-mm font-bold text-[20px] text-center pt-[24px] pb-[14px] flex justify-between">
                            <div></div>
                            Select List
                            <a class="mr-[20px]" @click="modelValue = false" href="#">
                                <fa-icon class="text-primary" icon="fa-solid fa-close" />
                            </a>
                        </div>
                        <hr class="border-[#F3F3F3]" />
                        <div class="py-2 px-4">
                            <div class="relative">
                                <div class="flex absolute inset-y-0 right-0 items-center pr-3 pointer-events-none">
                                    <svg aria-hidden="true" class="w-5 h-5 text-gray-500 dark:text-gray-400"
                                        fill="currentColor" viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg">
                                        <path fill-rule="evenodd"
                                            d="M8 4a4 4 0 100 8 4 4 0 000-8zM2 8a6 6 0 1110.89 3.476l4.817 4.817a1 1 0 01-1.414 1.414l-4.816-4.816A6 6 0 012 8z"
                                            clip-rule="evenodd"></path>
                                    </svg>
                                </div>
                                <input
                                    class="bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg focus:ring-blue-500 focus:border-blue-500 block w-full p-2.5"
                                    type="text" v-model="search" />
                            </div>
                        </div>
                        <ul v-if="options.length > 0"
                            class="text-sm text-gray-700 dark:text-gray-200 overflow-x-auto max-h-50 scrollbar scrollbar-v"
                            aria-labelledby="dropdownDefault">
                            <li v-for="(item, i) in options" :key="i">
                                <a @click="modelValue = false; handleChange(item.value); $emit('pick', item.value)"
                                    href="#"
                                    class="flex text-[16px] font-mn justify-between overflow-x-hidden py-2 px-5 hover:bg-gray-100 dark:hover:bg-gray-600 dark:hover:text-white">
                                    {{
                                            item.name
                                    }}
                                    <fa-icon v-if="item.value == inputValue" class="text-primary"
                                        icon="fa-solid fa-circle-check" />
                                </a>
                            </li>
                        </ul>
                        <div class="text-[14px] py-5 px-4 text-gray-700 text-center" v-else>No data</div>
                        <div class="h-5"></div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import { useField } from 'vee-validate';
import { computed, ref, toRef } from 'vue';

export default {
    name: 'VPopupList',
    props: {
        items: {
            type: Array,
            default: () => []
        },
        type: {
            type: String,
            default: "text",
        },
        value: {
            type: String,
            default: "",
        },
        name: {
            type: String,
            required: true,
        },
        label: {
            type: String,
            default: "",
        },
        errorMessageCustom: {
            type: String,
            default: "",
        },
        placeholder: {
            type: String,
            default: "",
        },
        disabled: {
            type: Boolean,
            default: false
        },
        isInvalid: {
            type: Boolean,
            default: false
        }
    },
    computed: {
        options() {
            return this.search ? this.items
                .filter(item => item.name.toLowerCase().includes(this.search.toLowerCase())) : this.items;
        }
    },
    data: () => ({
        search: ''
    }),
    setup(props) {
        const modelValue = ref(false);

        const name = toRef(props, "name");

        const onClickOutside = () => {
            modelValue.value = false;
        }

        const getOptionNameFromValue = (value) => {
            const option = props.items.find(option => option.value === value);
            return option ? option.name : null;
        };

        const title = computed(() => {
            if (inputValue.value) {
                return getOptionNameFromValue(inputValue.value);
            }
            return props.placeholder;
        });

        const {
            value: inputValue,
            errorMessage,
            handleBlur,
            handleChange,
            meta,
        } = useField(name, undefined, {
            initialValue: props.value,
        });

        const onShowModal = () => {
            modelValue.value = true;
        }

        return {
            modelValue,
            onShowModal,
            handleChange,
            handleBlur,
            errorMessage,
            inputValue,
            meta,
            onClickOutside,
            title
        }
    }
}
</script>
